!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! 2003.03.02 ORDistinctRead [Z, GLULX]
! Generally, the commands Read and Examine are treated the same and are mapped to the 
! same verb which simply displays the description.  This routine adds a behavior to 
! makes a distinction between reading and just looking at an object. 
! 
! To do this, ORDistinctRead relies upon a property called "read_value".  If present, 
! then the value of this property will be displayed in response to the READ command.  
! If not, then a message is printed explaining that the object "cannot be read, only 
! examined" and the normal description is printed.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!--------------------------------------------------------------------------------------
! Created by Jim Fisher
! AutoDep:	none
!--------------------------------------------------------------------------------------
! A more detailed description of this file, what it does, and how to use it goes here.
!--------------------------------------------------------------------------------------
! To register this module with your library, add the line:
!
!		#include "ORDistinctRead";					!Constant USE_ORDistinctRead; 
!	
!	to the library header file (OR_Library_Include).  To use in a game, add the line:
!
!		Constant USE_ORDistinctRead; to the game file;
!
!	to the game file;
!--------------------------------------------------------------------------------------
! Revision History
! 2002.01.03	Initial Creation (not really, but this is the earliest date I could find
!				without searching my code archive.)
! 2002.02.26	Fit to new template.
! 2002.04.03	modified faulty WORDSIZE definition.
! 2002.07.07	Added menu documentation.
! 2002.07.30	made a bogus object to declare the readvalue property rather than
!				making it a common property.
! 2002.10.19	Added autodep for ObjectInitialise 
! 2003.02.19	Added better ifdef for self docs
! 2003.03.02	Made the new grammar for read replace the previous grammar.  The 
!				topic token matches everything including things that should be 
!				rejected by the parser.
!--------------------------------------------------------------------------------------
#ifdef USE_ORDistinctRead;message "          Processing library extension ORDistinctRead...";
!--------------------------------------------------------------------------------------
! D E P E N D A N C I E S   section   (for bringing in dependant modules)
!--- sample forced include---   #ifndef USE_<REPLACEWITHINCLUDENAME>; Constant USE_<REPLACEWITHINCLUDENAME>; message "          ****Forcing inclusion of <REPLACEWITHINCLUDENAME>****"; #include "<REPLACEWITHINCLUDENAME>"; #endif; 
!--- #ifndef TARGET_GLULX; default WORDSIZE 2; #ifnot;default WORDSIZE 4; #endif; !--for GLULX compatability
!--------------------------------------------------------------------------------------
	#ifndef USE_ORObjectInitialise; Constant USE_ORObjectInitialise; message "          ****Forcing inclusion of ORObjectInitialise****"; #include "ORObjectInitialise"; #endif; 

!--------------------------------------------------------------------------------------
#ifdef REPLACEPOINT; #ifndef ORDistinctRead_DONEREPLACE; constant ORDistinctRead_DONEREPLACE; 
!--------------------------------------------------------------------------------------
! R E P L A C E   section (for code that preceeds the inclusion of PARSER)
!--------------------------------------------------------------------------------------
	object with read_value;
!--------------------------------------------------------------------------------------
#endif;#endif;#ifdef MESSAGEPOINT; #ifndef ORDistinctRead_DONEMESSAGE; constant ORDistinctRead_DONEMESSAGE; 
!--------------------------------------------------------------------------------------
! M E S S A G E   section (for code that falls between PARSER and VERBLIB )
!--- Uncomment to check for OREnglish--- #ifndef OREnglish; message "ERROR!!!! ORDistinctRead requires the OREnglish file.";#endif; 
!--------------------------------------------------------------------------------------


!--------------------------------------------------------------------------------------
#endif; #endif; #ifdef CODEPOINT; #ifndef ORDistinctRead_DONECODE;constant ORDistinctRead_DONECODE; 
!--------------------------------------------------------------------------------------
! C O D E   section (for code that falls between VERBLIB and GRAMMAR)
!--------------------------------------------------------------------------------------


!--------------------------------------------------------------------------------------
#endif; #endif; #ifdef GRAMMARPOINT; #ifndef ORDistinctRead_DONEGRAMMAR; constant ORDistinctRead_DONEGRAMMAR; #ifdef ORDistinctRead_DONEGRAMMAR; #endif; !--just to supress warning
!--------------------------------------------------------------------------------------
! G R A M M A R   section (for code that follows the inclusion of GRAMMAR)
!--------------------------------------------------------------------------------------
	Extend "read" replace 
		* noun		->Read
	;
	[ReadSub;
		if(noun provides read_value) printorrun(noun,read_value);
		else {
			print "(",(The)noun," could not be ",(strong)"read",", just ",(strong)"examined","...)^";
			ExamineSub();	
		}
	];
#ifdef ORMenuCatch;
	!--Commands, document thyself.
	ORMenu ORHelpRead "Read" with text "For the sake of completeness, it is worth noting that the commands ~READ~ and ~EXAMINE~ are treated separately and may be used with differing results."
		,	object_initialise[;	if(ORMenuCatch~=0) move self to ORMenuCatch; ]
	;
#endif;
!--------------------------------------------------------------------------------------
#endif; #endif; #endif;
