!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! 2002.08.31 ORKnowledge [REMOVED]
! This is an object which embodies a player character's personal knowledge.
! It implements verbs such as REMEMBER, RECALL, and CONSULT MEMORY.
!
! NOTE: This module has been retired from the ORLibrary proper and placed in the 
! ORArchive.zip file.  See ORKnowledgeTopic.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! Created by Jim Fisher
!	It exposes a method "knowledgeof" that is intended to be overridden to output "recollections ".
!	In the game's Initialise() routine, this method needs to be set the appropriate 
!	developer-defined routine as follows:
!
!		memory.knowledgeof=knowledge;
!
!	Where knowledge is defined as something like:
!
!		[knowledge w;
!			switch(w)	
!			{
!				'knowledge', 'memory'	:	print "Although you know lots of things, topics that are of particular pertinence right now include:";
!											print "^@@9your KNOWLEDGE (you know what you know)";
!											print "^@@9your dog";
!											print "^@@9your cat";
!											print "^@@9your mouse";
!				'dog', 'scrappy':			print "Scrappy likes to chase ~Guile~ your cat.";
!				'cat', 'guile'			:	print "You bought ~Guile~ to catch a mouse under the fridge, but most of the cat's time is spent running from your dog.";
!				'mouse'					:	print "That stupid mouse, lives under your fridge and sneaks out to eat all of your cheese!";
!				default					:	print "You don't recall anything unusual about that subject.";
!			}
!		];
!
!	Once this is done, the player can issue commands like:
!		
!		REMEMBER DOG, or
!		RECALL MOUSE, or
!		CONSULT MEMORY ON CAT
!
!	It is also possible to change a characters knowledgebase in mid-game (simulating amnesia or 
!	body-swapping) by re-assigning memory.knowledgeof.
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!	Created by Jim Fisher: 2001.04.20
!	To add this module to your library, add the line:
!
!		#include ">ORKnowledge.h";		!		Constant USE_ORKnowledge; 
!	
!	to the OR_Library_Include.h file.
!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

#ifdef USE_ORKnowledge;
	message "          Processing library extension ORKnowledge...";
	#ifdef GRAMMARPOINT;
		#ifndef ORKnowledge_DONEGRAMMAR;
			constant ORKnowledge_DONEGRAMMAR; #ifdef ORKnowledge_DONEGRAMMAR; #endif;
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! GRAMMAR section begins here
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	!---- remember ----------------------------------------------
	Verb "remember"
		* topic					->	Remember
	;
	Verb "recall" 
		* topic					->	Remember
	;
	[RememberSub;
		<<Consult ORKnowledge>>;
	];
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
		#endif; !donegrammar
	#ifnot; !GRAMMARPOINT
		#ifdef CODEPOINT; 
			#ifndef ORKnowledge_DONECODE;
				constant ORKnowledge_DONECODE; #ifdef ORKnowledge_DONECODE; #endif;
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! CODE section begins here
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	object ORKnowledge "memory" selfobj
		with	name "memory" "knowledge" 
		,		invent
				[; return true;
				]
		,		article "your"
		,		knowledgeof 
				[w;
					w=null;
					return false;
				]
		,		before
				[w r c;
					Give, Show, PutOn, Take, Drop, Remove, Transfer, Insert: print_ret "Sometimes you'd like to do that to your memory, but since it is all stored inside your head you would find that somewhat difficult.";
					Consult:
						wn=consult_from;
						r=false;
						for(c=0:c<consult_words && r==false:c++)
						{
							w=NextWord();
							r=self.knowledgeof(w);
						}
						if(r==false) print_ret "You think back for a moment but can't seem to recall special about that subject.";
						return true;
				]
		has		static scenery
	;
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
			#endif; !donecode
		#ifnot; !codepoint
			#ifdef MESSAGEPOINT;
				#ifndef ORKnowledge_DONEMESSAGE;
					constant ORKnowledge_DONEMESSAGE; #ifdef ORKnowledge_DONEMESSAGE; #endif;
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! MESSAGE section begins here
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!--- put message implementation here
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
				#endif; !donereplace
			#ifnot; !messagepoint
				#ifdef REPLACEPOINT;
					#ifndef ORKnowledge_DONEREPLACE;
						constant ORKnowledge_DONEREPLACE; #ifdef ORKnowledge_DONEREPLACE; #endif;
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
! REPLACE section begins here
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!--- put replace implementation here
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!	
					#endif; !donereplace
				#ifnot; !replacepoint
					message "ERROR! processing ORKnowledge without proper sectioning constants defined.  This file should only be included from the ORLib.h entry point";
				#endif; !REPLACEPOINT
			#endif; !MESSAGEPOINT
		#endif; !CODEPOINT
	#endif; !GRAMMARPOINT
#endif;
